Index: drivers/char/tty_io.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/tty_io.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/tty_io.c	22 Jul 2004 19:49:51 -0000	1.1
+++ drivers/char/tty_io.c	4 Aug 2004 01:28:46 -0000	1.2
@@ -19,7 +19,7 @@
  * Also restructured routines so that there is more of a separation
  * between the high-level tty routines (tty_io.c and tty_ioctl.c) and
  * the low-level tty routines (serial.c, pty.c, console.c).  This
- * makes for cleaner and more compact code.  -TYT, 9/17/92 
+ * makes for cleaner and more compact code.  -TYT, 9/17/92
  *
  * Modified by Fred N. van Kempen, 01/29/93, to add line disciplines
  * which can be dynamically activated and de-activated by the line
@@ -41,7 +41,7 @@
  *
  * New TIOCLINUX variants added.
  *	-- mj@k332.feld.cvut.cz, 19-Nov-95
- * 
+ *
  * Restrict vt switching via ioctl()
  *      -- grif@cs.ucr.edu, 5-Dec-95
  *
@@ -142,6 +142,7 @@
 extern int serial167_init(void);
 extern long serial167_console_init(void);
 extern void console_8xx_init(void);
+extern void au1x00_serial_console_init(void);
 extern int rs_8xx_init(void);
 extern void mac_scc_console_init(void);
 extern void hwc_console_init(void);
@@ -152,12 +153,18 @@
 extern void tub3270_init(void);
 extern void uart_console_init(void);
 extern void sgi_serial_console_init(void);
+extern void sn_sal_serial_console_init(void);
 extern void sci_console_init(void);
+extern void dec_serial_console_init(void);
 extern void tx3912_console_init(void);
 extern void tx3912_rs_init(void);
 extern void txx927_console_init(void);
+extern void txx9_rs_init(void);
+extern void txx9_serial_console_init(void);
 extern void sb1250_serial_console_init(void);
+extern void arc_console_init(void);
 extern void rs285_console_init(void);
+extern int hvc_console_init(void);
 
 #ifndef MIN
 #define MIN(a,b)	((a) < (b) ? (a) : (b))
@@ -194,7 +201,7 @@
 	else
 		sprintf(buf, name,
 			idx + tty->driver.name_base);
-		
+
 	return buf;
 }
 
@@ -232,7 +239,7 @@
 #ifdef CHECK_TTY_COUNT
 	struct list_head *p;
 	int count = 0;
-	
+
 	file_list_lock();
 	for(p = tty->tty_files.next; p != &tty->tty_files; p = p->next) {
 		if(list_entry(p, struct file, f_list)->private_data == tty)
@@ -248,7 +255,7 @@
 				    "!= #fd's(%d) in %s\n",
 		       kdevname(tty->device), tty->count, count, routine);
 		return count;
-       }	
+       }
 #endif
 	return 0;
 }
@@ -257,14 +264,14 @@
 {
 	if (disc < N_TTY || disc >= NR_LDISCS)
 		return -EINVAL;
-	
+
 	if (new_ldisc) {
 		ldiscs[disc] = *new_ldisc;
 		ldiscs[disc].flags |= LDISC_FLAG_DEFINED;
 		ldiscs[disc].num = disc;
 	} else
 		memset(&ldiscs[disc], 0, sizeof(struct tty_ldisc));
-	
+
 	return 0;
 }
 
@@ -294,7 +301,7 @@
 	o_ldisc = tty->ldisc;
 
 	tty_wait_until_sent(tty, 0);
-	
+
 	/* Shutdown the current discipline. */
 	if (tty->ldisc.close)
 		(tty->ldisc.close)(tty);
@@ -332,7 +339,7 @@
 {
 	int	major, minor;
 	struct tty_driver *p;
-	
+
 	minor = MINOR(device);
 	major = MAJOR(device);
 
@@ -449,9 +456,7 @@
 		redirect = NULL;
 	}
 	spin_unlock(&redirect_lock);
-	if (f)
-		fput(f);
-	
+
 	check_tty_count(tty, "do_tty_hangup");
 	file_list_lock();
 	for (l = tty->tty_files.next; l != &tty->tty_files; l = l->next) {
@@ -468,7 +473,7 @@
 		filp->f_op = &hung_up_tty_fops;
 	}
 	file_list_unlock();
-	
+
 	/* FIXME! What are the locking issues here? This may me overdoing things.. */
 	{
 		unsigned long flags;
@@ -505,7 +510,7 @@
 						"error %d\n", -i);
 		}
 	}
-	
+
 	read_lock(&tasklist_lock);
  	for_each_task(p) {
 		if ((tty->session > 0) && (p->session == tty->session) &&
@@ -537,13 +542,15 @@
 	} else if (tty->driver.hangup)
 		(tty->driver.hangup)(tty);
 	unlock_kernel();
+	if (f)
+		fput(f);
 }
 
 void tty_hangup(struct tty_struct * tty)
 {
 #ifdef TTY_DEBUG_HANGUP
 	char	buf[64];
-	
+
 	printk(KERN_DEBUG "%s hangup...\n", tty_name(tty, buf));
 #endif
 	schedule_task(&tty->tq_hangup);
@@ -643,7 +650,7 @@
 	wake_up_interruptible(&tty->write_wait);
 }
 
-static ssize_t tty_read(struct file * file, char * buf, size_t count, 
+static ssize_t tty_read(struct file * file, char * buf, size_t count,
 			loff_t *ppos)
 {
 	int i;
@@ -700,7 +707,7 @@
 	size_t count)
 {
 	ssize_t ret = 0, written = 0;
-	
+
 	if (file->f_flags & O_NONBLOCK) {
 		if (down_trylock(&tty->atomic_write))
 			return -EAGAIN;
@@ -828,7 +835,7 @@
 	struct tty_struct *tty, *o_tty;
 	struct termios *tp, **tp_loc, *o_tp, **o_tp_loc;
 	struct termios *ltp, **ltp_loc, *o_ltp, **o_ltp_loc;
-	struct tty_driver *driver;	
+	struct tty_driver *driver;
 	int retval=0;
 	int idx;
 
@@ -838,7 +845,7 @@
 
 	idx = MINOR(device) - driver->minor_start;
 
-	/* 
+	/*
 	 * Check whether we need to acquire the tty semaphore to avoid
 	 * race conditions.  For now, play it safe.
 	 */
@@ -852,7 +859,7 @@
 	 * First time open is complex, especially for PTY devices.
 	 * This code guarantees that either everything succeeds and the
 	 * TTY is ready for operation, or else the table slots are vacated
-	 * and the allocated memory released.  (Except that the termios 
+	 * and the allocated memory released.  (Except that the termios
 	 * and locked termios may be retained.)
 	 */
 
@@ -931,13 +938,13 @@
 		o_tty->link = tty;
 	}
 
-	/* 
+	/*
 	 * All structures have been allocated, so now we install them.
-	 * Failures after this point use release_mem to clean up, so 
+	 * Failures after this point use release_mem to clean up, so
 	 * there's no need to null out the local pointers.
 	 */
 	driver->table[idx] = tty;
-	
+
 	if (!*tp_loc)
 		*tp_loc = tp;
 	if (!*ltp_loc)
@@ -947,7 +954,7 @@
 	(*driver->refcount)++;
 	tty->count++;
 
-	/* 
+	/*
 	 * Structures all installed ... call the ldisc open routines.
 	 * If we fail here just call release_mem to clean up.  No need
 	 * to decrement the use counts, as release_mem doesn't care.
@@ -981,7 +988,7 @@
 	if (driver->type == TTY_DRIVER_TYPE_PTY &&
 	    driver->subtype == PTY_TYPE_MASTER) {
 		/*
-		 * special case for PTY masters: only one open permitted, 
+		 * special case for PTY masters: only one open permitted,
 		 * and the slave side open count is incremented as well.
 		 */
 		if (tty->count) {
@@ -995,7 +1002,7 @@
 
 success:
 	*ret_tty = tty;
-	
+
 	/* All paths come through here to release the semaphore */
 end_init:
 	up_tty_sem(idx);
@@ -1043,7 +1050,7 @@
 		}
 		o_tty->magic = 0;
 		(*o_tty->driver.refcount)--;
-		list_del(&o_tty->tty_files);
+		list_del_init(&o_tty->tty_files);
 		free_tty_struct(o_tty);
 	}
 
@@ -1055,7 +1062,7 @@
 	}
 	tty->magic = 0;
 	(*tty->driver.refcount)--;
-	list_del(&tty->tty_files);
+	list_del_init(&tty->tty_files);
 	free_tty_struct(tty);
 }
 
@@ -1073,7 +1080,7 @@
 	int	pty_master, tty_closing, o_tty_closing, do_sleep;
 	int	idx;
 	char	buf[64];
-	
+
 	tty = (struct tty_struct *)filp->private_data;
 	if (tty_paranoia_check(tty, filp->f_dentry->d_inode->i_rdev, "release_dev"))
 		return;
@@ -1131,7 +1138,7 @@
 			       idx, kdevname(tty->device));
 			return;
 		}
-		if (o_tty->termios_locked != 
+		if (o_tty->termios_locked !=
 		      tty->driver.other->termios_locked[idx]) {
 			printk(KERN_DEBUG "release_dev: other->termios_locked["
 					  "%d] not o_termios_locked for (%s)\n",
@@ -1197,11 +1204,11 @@
 		printk(KERN_WARNING "release_dev: %s: read/write wait queue "
 				    "active!\n", tty_name(tty, buf));
 		schedule();
-	}	
+	}
 
 	/*
-	 * The closing flags are now consistent with the open counts on 
-	 * both sides, and we've completed the last operation that could 
+	 * The closing flags are now consistent with the open counts on
+	 * both sides, and we've completed the last operation that could
 	 * block, so it's safe to proceed with closing.
 	 */
 	if (pty_master) {
@@ -1259,7 +1266,7 @@
 	/* check whether both sides are closing ... */
 	if (!tty_closing || (o_tty && !o_tty_closing))
 		return;
-	
+
 #ifdef TTY_DEBUG_HANGUP
 	printk(KERN_DEBUG "freeing tty structure...");
 #endif
@@ -1277,14 +1284,14 @@
 			(o_tty->ldisc.close)(o_tty);
 		o_tty->ldisc = ldiscs[N_TTY];
 	}
-	
+
 	/*
-	 * Make sure that the tty's task queue isn't activated. 
+	 * Make sure that the tty's task queue isn't activated.
 	 */
 	run_task_queue(&tq_timer);
 	flush_scheduled_tasks();
 
-	/* 
+	/*
 	 * The release_mem function takes care of the details of clearing
 	 * the slots and preserving the termios structure.
 	 */
@@ -1475,7 +1482,7 @@
 	tty = (struct tty_struct *)filp->private_data;
 	if (tty_paranoia_check(tty, filp->f_dentry->d_inode->i_rdev, "tty_fasync"))
 		return 0;
-	
+
 	retval = fasync_helper(fd, filp, on, &tty->fasync);
 	if (retval <= 0)
 		return retval;
@@ -1690,7 +1697,7 @@
 
 static int tty_generic_brk(struct tty_struct *tty, struct file *file, unsigned int cmd, unsigned long arg)
 {
-	if (cmd == TCSBRK && arg) 
+	if (cmd == TCSBRK && arg)
 	{
 		/* tcdrain case */
 		int retval = tty_check_change(tty);
@@ -1711,7 +1718,7 @@
 {
 	struct tty_struct *tty, *real_tty;
 	int retval;
-	
+
 	tty = (struct tty_struct *)file->private_data;
 	if (tty_paranoia_check(tty, inode->i_rdev, "tty_ioctl"))
 		return -EINVAL;
@@ -1731,7 +1738,7 @@
 			if (tty->driver.ioctl)
 				return tty->driver.ioctl(tty, file, cmd, arg);
 			return -EINVAL;
-			
+
 		/* These two ioctl's always return success; even if */
 		/* the driver doesn't support them. */
 		case TCSBRK:
@@ -1754,7 +1761,7 @@
 	case TIOCSBRK:
 	case TIOCCBRK:
 	case TCSBRK:
-	case TCSBRKP:			
+	case TCSBRKP:
 		retval = tty_check_change(tty);
 		if (retval)
 			return retval;
@@ -1817,7 +1824,7 @@
 		case TIOCSBRK:	/* Turn break on, unconditionally */
 			tty->driver.break_ctl(tty, -1);
 			return 0;
-			
+
 		case TIOCCBRK:	/* Turn break off, unconditionally */
 			tty->driver.break_ctl(tty, 0);
 			return 0;
@@ -1830,7 +1837,7 @@
 			if (!arg)
 				return send_break(tty, HZ/4);
 			return 0;
-		case TCSBRKP:	/* support for POSIX tcsendbreak() */	
+		case TCSBRKP:	/* support for POSIX tcsendbreak() */
 			return send_break(tty, arg ? arg*(HZ/10) : HZ/4);
 	}
 	if (tty->driver.ioctl) {
@@ -1852,7 +1859,7 @@
  * prevent trojan horses by killing all processes associated with this
  * tty when the user hits the "Secure Attention Key".  Required for
  * super-paranoid applications --- see the Orange Book for more details.
- * 
+ *
  * This code could be nicer; ideally it should send a HUP, wait a few
  * seconds, then send a INT, and then a KILL signal.  But you then
  * have to coordinate with the init process, since all processes associated
@@ -1876,7 +1883,7 @@
 	int session;
 	int		i;
 	struct file	*filp;
-	
+
 	if (!tty)
 		return;
 	session  = tty->session;
@@ -1961,7 +1968,7 @@
 	count = tty->flip.count;
 	tty->flip.count = 0;
 	restore_flags(flags);
-	
+
 	tty->ldisc.receive_buf(tty, cp, fp, count);
 }
 
@@ -1993,7 +2000,7 @@
 	i = cflag & CBAUD;
 	if (i & CBAUDEX) {
 		i &= ~CBAUDEX;
-		if (i < 1 || i+15 >= n_baud_table) 
+		if (i < 1 || i+15 >= n_baud_table)
 			tty->termios->c_cflag &= ~CBAUDEX;
 		else
 			i += 15;
@@ -2006,7 +2013,7 @@
 		}
 		return(tty->alt_speed);
 	}
-	
+
 	return baud_table[i];
 }
 
@@ -2072,7 +2079,7 @@
 				mode |= S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH;
 			break;
 	}
-	if ( (minor <  driver->minor_start) || 
+	if ( (minor <  driver->minor_start) ||
 	     (minor >= driver->minor_start + driver->num) ) {
 		printk(KERN_ERR "Attempt to register invalid minor number "
 		       "with devfs (%d:%d).\n", (int)driver->major,(int)minor);
@@ -2125,12 +2132,12 @@
 
 	if (!driver->put_char)
 		driver->put_char = tty_default_put_char;
-	
+
 	driver->prev = 0;
 	driver->next = tty_drivers;
 	if (tty_drivers) tty_drivers->prev = driver;
 	tty_drivers = driver;
-	
+
 	if ( !(driver->flags & TTY_DRIVER_NO_DEVFS) ) {
 		for(i = 0; i < driver->num; i++)
 		    tty_register_devfs(driver, 0, driver->minor_start + i);
@@ -2149,7 +2156,7 @@
 	int	i, found = 0;
 	struct termios *tp;
 	const char *othername = NULL;
-	
+
 	if (*driver->refcount)
 		return -EBUSY;
 
@@ -2159,7 +2166,7 @@
 		else if (p->major == driver->major)
 			othername = p->name;
 	}
-	
+
 	if (!found)
 		return -ENOENT;
 
@@ -2174,7 +2181,7 @@
 		driver->prev->next = driver->next;
 	else
 		tty_drivers = driver->next;
-	
+
 	if (driver->next)
 		driver->next->prev = driver->prev;
 
@@ -2214,7 +2221,7 @@
 	(void) tty_register_ldisc(N_TTY, &tty_ldisc_N_TTY);
 
 	/*
-	 * Set up the standard termios.  Individual tty drivers may 
+	 * Set up the standard termios.  Individual tty drivers may
 	 * deviate from this; this is used as a template.
 	 */
 	memset(&tty_std_termios, 0, sizeof(struct termios));
@@ -2226,20 +2233,23 @@
 		ECHOCTL | ECHOKE | IEXTEN;
 
 	/*
-	 * set up the console device so that later boot sequences can 
+	 * set up the console device so that later boot sequences can
 	 * inform about problems etc..
 	 */
 #ifdef CONFIG_EARLY_PRINTK
-	disable_early_printk(); 
+	disable_early_printk();
+#endif
+#ifdef CONFIG_HVC_CONSOLE
+	hvc_console_init();
 #endif
 #ifdef CONFIG_VT
 	con_init();
 #endif
-#ifdef CONFIG_AU1000_SERIAL_CONSOLE
-	au1000_serial_console_init();
+#ifdef CONFIG_AU1X00_SERIAL_CONSOLE
+	au1x00_serial_console_init();
 #endif
 #ifdef CONFIG_SERIAL_CONSOLE
-#if (defined(CONFIG_8xx) || defined(CONFIG_8260))
+#if (defined(CONFIG_8xx) || defined(CONFIG_CPM2))
 	console_8xx_init();
 #elif defined(CONFIG_MAC_SERIAL) && defined(CONFIG_SERIAL)
 	if (_machine == _MACH_Pmac)
@@ -2253,9 +2263,6 @@
 #elif defined(CONFIG_SERIAL)
 	serial_console_init();
 #endif /* CONFIG_8xx */
-#ifdef CONFIG_SGI_SERIAL
-	sgi_serial_console_init();
-#endif
 #if defined(CONFIG_MVME162_SCC) || defined(CONFIG_BVME6000_SCC) || defined(CONFIG_MVME147_SCC)
 	vme_scc_console_init();
 #endif
@@ -2266,6 +2273,9 @@
 	sci_console_init();
 #endif
 #endif
+#ifdef CONFIG_SERIAL_DEC_CONSOLE
+	dec_serial_console_init();
+#endif
 #ifdef CONFIG_TN3270_CONSOLE
 	tub3270_con_init();
 #endif
@@ -2290,9 +2300,15 @@
 #ifdef CONFIG_TXX927_SERIAL_CONSOLE
 	txx927_console_init();
 #endif
+#ifdef CONFIG_SERIAL_TXX9_CONSOLE
+	txx9_serial_console_init();
+#endif
 #ifdef CONFIG_SIBYTE_SB1250_DUART_CONSOLE
 	sb1250_serial_console_init();
 #endif
+#ifdef CONFIG_IP22_SERIAL
+	sgi_serial_console_init();
+#endif
 #ifdef CONFIG_SERIAL_21285_CONSOLE
 	rs285_console_init();
 #endif
@@ -2328,7 +2344,7 @@
 	dev_tty_driver.num = 1;
 	dev_tty_driver.type = TTY_DRIVER_TYPE_SYSTEM;
 	dev_tty_driver.subtype = SYSTEM_TYPE_TTY;
-	
+
 	if (tty_register_driver(&dev_tty_driver))
 		panic("Couldn't register /dev/tty driver\n");
 
@@ -2344,7 +2360,7 @@
 		panic("Couldn't register /dev/console driver\n");
 
 	/* console calls tty_register_driver() before kmalloc() works.
-	 * Thus, we can't devfs_register() then.  Do so now, instead. 
+	 * Thus, we can't devfs_register() then.  Do so now, instead.
 	 */
 #ifdef CONFIG_VT
 	con_init_devfs();
@@ -2362,7 +2378,7 @@
 	if (tty_register_driver(&dev_ptmx_driver))
 		panic("Couldn't register /dev/ptmx driver\n");
 #endif
-	
+
 #ifdef CONFIG_VT
 	dev_console_driver = dev_tty_driver;
 	dev_console_driver.driver_name = "/dev/vc/0";
@@ -2377,6 +2393,12 @@
 	kbd_init();
 #endif
 
+#ifdef CONFIG_SGI_L1_SERIAL_CONSOLE
+	if (ia64_platform_is("sn2")) {
+		sn_sal_serial_console_init();
+		return; /* only one console right now for SN2 */
+	}
+#endif
 #ifdef CONFIG_ESPSERIAL  /* init ESP before rs, so rs doesn't see the port */
 	espserial_init();
 #endif
@@ -2410,16 +2432,16 @@
 #ifdef CONFIG_SPECIALIX
 	specialix_init();
 #endif
-#if (defined(CONFIG_8xx) || defined(CONFIG_8260))
+#if (defined(CONFIG_8xx) || defined(CONFIG_CPM2))
 	rs_8xx_init();
 #endif /* CONFIG_8xx */
 	pty_init();
 #ifdef CONFIG_MOXA_SMARTIO
 	mxser_init();
-#endif	
+#endif
 #ifdef CONFIG_MOXA_INTELLIO
 	moxa_init();
-#endif	
+#endif
 #ifdef CONFIG_VT
 	vcs_init();
 #endif
Index: drivers/char/wdt977.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/wdt977.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/wdt977.c	22 Jul 2004 19:49:52 -0000	1.1
+++ drivers/char/wdt977.c	4 Aug 2004 01:28:46 -0000	1.2
@@ -27,6 +27,7 @@
 #include <asm/io.h>
 #include <asm/system.h>
 #include <asm/mach-types.h>
+#include <asm/uaccess.h>
 
 #define WATCHDOG_MINOR	130
 
Index: drivers/char/wdt_pci.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/wdt_pci.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/wdt_pci.c	22 Jul 2004 19:49:52 -0000	1.1
+++ drivers/char/wdt_pci.c	4 Aug 2004 01:28:46 -0000	1.2
@@ -557,7 +557,7 @@
 
 	ret = register_reboot_notifier (&wdtpci_notifier);
 	if (ret) {
-		printk (KERN_ERR PFX "can't misc_register on minor=%d\n", WATCHDOG_MINOR);
+		printk (KERN_ERR PFX "can't register_reboot_notifier on minor=%d\n", WATCHDOG_MINOR);
 		goto out_misc;
 	}
 #ifdef CONFIG_WDT_501
Index: drivers/char/agp/agp.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/char/agp/agp.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/char/agp/agp.h	22 Jul 2004 19:49:52 -0000	1.1
+++ drivers/char/agp/agp.h	4 Aug 2004 01:28:46 -0000	1.2
@@ -166,9 +166,18 @@
 #ifndef PCI_DEVICE_ID_VIA_8363_0
 #define PCI_DEVICE_ID_VIA_8363_0      0x0305
 #endif
+#ifndef PCI_DEVICE_ID_VIA_8601_0
+#define PCI_DEVICE_ID_VIA_8601_0      0x0601
+#endif
 #ifndef PCI_DEVICE_ID_VIA_82C694X_0
 #define PCI_DEVICE_ID_VIA_82C694X_0      0x0605
 #endif
+#ifndef PCI_DEVICE_ID_VIA_8380_0
+#define PCI_DEVICE_ID_VIA_8380_0	0x0204
+#endif
+#ifndef PCI_DEVICE_ID_VIA_8385_0
+#define PCI_DEVICE_ID_VIA_8385_0	0x3188
+#endif 
 #ifndef PCI_DEVICE_ID_INTEL_810_0
 #define PCI_DEVICE_ID_INTEL_810_0       0x7120
 #endif
@@ -184,6 +193,24 @@
 #ifndef PCI_DEVICE_ID_INTEL_830_M_1
 #define PCI_DEVICE_ID_INTEL_830_M_1     0x3577
 #endif
+#ifndef PCI_DEVICE_ID_INTEL_855_GM_0
+#define PCI_DEVICE_ID_INTEL_855_GM_0	0x3580
+#endif
+#ifndef PCI_DEVICE_ID_INTEL_855_GM_1
+#define PCI_DEVICE_ID_INTEL_855_GM_1	0x3582
+#endif
+#ifndef PCI_DEVICE_ID_INTEL_855_PM_0
+#define PCI_DEVICE_ID_INTEL_855_PM_0	0x3340
+#endif
+#ifndef PCI_DEVICE_ID_INTEL_855_PM_1
+#define PCI_DEVICE_ID_INTEL_855_PM_1	0x3342
+#endif
+#ifndef PCI_DEVICE_ID_INTEL_865_G_0
+#define PCI_DEVICE_ID_INTEL_865_G_0	0x2570
+#endif
+#ifndef PCI_DEVICE_ID_INTEL_865_G_1
+#define PCI_DEVICE_ID_INTEL_865_G_1	0x2572
+#endif
 #ifndef PCI_DEVICE_ID_INTEL_820_0
 #define PCI_DEVICE_ID_INTEL_820_0       0x2500
 #endif
@@ -202,6 +229,12 @@
 #ifndef PCI_DEVICE_ID_INTEL_860_0
 #define PCI_DEVICE_ID_INTEL_860_0     0x2531
 #endif
+#ifndef PCI_DEVICE_ID_INTEL_7205_0
+#define PCI_DEVICE_ID_INTEL_7205_0     0x255d
+#endif
+#ifndef PCI_DEVICE_ID_INTEL_7505_0
+#define PCI_DEVICE_ID_INTEL_7505_0     0x2550
+#endif
 #ifndef PCI_DEVICE_ID_INTEL_810_DC100_0
 #define PCI_DEVICE_ID_INTEL_810_DC100_0 0x7122
 #endif
@@ -229,6 +262,9 @@
 #ifndef PCI_DEVICE_ID_INTEL_82443GX_1
 #define PCI_DEVICE_ID_INTEL_82443GX_1   0x71a1
 #endif
+#ifndef PCI_DEVICE_ID_INTEL_460GX
+#define PCI_DEVICE_ID_INTEL_460GX       0x84ea
+#endif
 #ifndef PCI_DEVICE_ID_AMD_IRONGATE_0
 #define PCI_DEVICE_ID_AMD_IRONGATE_0    0x7006
 #endif
@@ -271,6 +307,33 @@
 #ifndef PCI_DEVICE_ID_AL_M1671_0
 #define PCI_DEVICE_ID_AL_M1671_0	0x1671
 #endif
+#ifndef PCI_VENDOR_ID_ATI
+#define PCI_VENDOR_ID_ATI		0x1002
+#endif
+#ifndef PCI_DEVICE_ID_ATI_RS100
+#define PCI_DEVICE_ID_ATI_RS100		0xcab0
+#endif
+#ifndef PCI_DEVICE_ID_ATI_RS200
+#define PCI_DEVICE_ID_ATI_RS200		0xcab2
+#endif
+#ifndef PCI_DEVICE_ID_ATI_RS250
+#define PCI_DEVICE_ID_ATI_RS250		0xcab3
+#endif
+#ifndef PCI_DEVICE_ID_ATI_RS200_B
+#define PCI_DEVICE_ID_ATI_RS200_B	0xcbb3
+#endif
+#ifndef PCI_DEVICE_ID_ATI_RS300_100
+#define PCI_DEVICE_ID_ATI_RS300_100	0x5830
+#endif
+#ifndef PCI_DEVICE_ID_ATI_RS300_133
+#define PCI_DEVICE_ID_ATI_RS300_133	0x5831
+#endif
+#ifndef PCI_DEVICE_ID_ATI_RS300_166
+#define PCI_DEVICE_ID_ATI_RS300_166	0x5832
+#endif
+#ifndef PCI_DEVICE_ID_ATI_RS300_200
+#define PCI_DEVICE_ID_ATI_RS300_200	0x5833
+#endif
 
 /* intel register */
 #define INTEL_APBASE    0x10
@@ -280,6 +343,36 @@
 #define INTEL_NBXCFG    0x50
 #define INTEL_ERRSTS    0x91
 
+/* Intel 460GX Registers */
+#define INTEL_I460_APBASE		0x10
+#define INTEL_I460_BAPBASE		0x98
+#define INTEL_I460_GXBCTL		0xa0
+#define INTEL_I460_AGPSIZ		0xa2
+#define INTEL_I460_ATTBASE		0xfe200000
+#define INTEL_I460_GATT_VALID		(1UL << 24)
+#define INTEL_I460_GATT_COHERENT	(1UL << 25)
+/* Intel 855GM/852GM registers */
+#define I855_GMCH_CTRL             0x52
+#define I855_GMCH_ENABLED          0x4
+#define I855_GMCH_GMS_MASK         (0x7 << 4)
+#define I855_GMCH_GMS_STOLEN_0M    0x0
+#define I855_GMCH_GMS_STOLEN_1M    (0x1 << 4)
+#define I855_GMCH_GMS_STOLEN_4M    (0x2 << 4)
+#define I855_GMCH_GMS_STOLEN_8M    (0x3 << 4)
+#define I855_GMCH_GMS_STOLEN_16M   (0x4 << 4)
+#define I855_GMCH_GMS_STOLEN_32M   (0x5 << 4)
+#define I85X_CAPID                 0x44
+#define I85X_VARIANT_MASK          0x7
+#define I85X_VARIANT_SHIFT         5
+#define I855_GME                   0x0
+#define I855_GM                    0x4
+#define I852_GME                   0x2
+#define I852_GM                    0x5
+#define I855_PME                   0x0
+#define I855_PM                    0x4
+#define I852_PME                   0x2
+#define I852_PM                    0x5
+
 /* intel i830 registers */
 #define I830_GMCH_CTRL             0x52
 #define I830_GMCH_ENABLED          0x4
@@ -323,6 +416,10 @@
 #define INTEL_I860_MCHCFG	0x50
 #define INTEL_I860_ERRSTS	0xc8
 
+/* intel i7505 registers */
+#define INTEL_I7505_MCHCFG	0x50
+#define INTEL_I7505_ERRSTS	0x42
+
 /* intel i810 registers */
 #define I810_GMADDR 0x10
 #define I810_MMADDR 0x14
@@ -412,13 +509,48 @@
 #define SVWRKS_POSTFLUSH  0x14
 #define SVWRKS_DIRFLUSH   0x0c
 
-/* HP ZX1 SBA registers */
-#define HP_ZX1_CTRL		0x200
+/* NVIDIA registers */
+#define NVIDIA_0_APBASE     0x10
+#define NVIDIA_0_APSIZE     0x80
+#define NVIDIA_1_WBC        0xf0
+#define NVIDIA_2_GARTCTRL   0xd0
+#define NVIDIA_2_APBASE     0xd8
+#define NVIDIA_2_APLIMIT    0xdc
+#define NVIDIA_2_ATTBASE(i) (0xe0 + (i) * 4)
+#define NVIDIA_3_APBASE     0x50
+#define NVIDIA_3_APLIMIT    0x54
+
+/* NVIDIA x86-64 registers */
+#define NVIDIA_X86_64_0_APBASE		0x10
+#define NVIDIA_X86_64_1_APBASE1		0x50
+#define NVIDIA_X86_64_1_APLIMIT1	0x54
+#define NVIDIA_X86_64_1_APSIZE		0xa8
+#define NVIDIA_X86_64_1_APBASE2		0xd8
+#define NVIDIA_X86_64_1_APLIMIT2	0xdc
+
+/* HP ZX1 IOC registers */
 #define HP_ZX1_IBASE		0x300
 #define HP_ZX1_IMASK		0x308
 #define HP_ZX1_PCOM		0x310
 #define HP_ZX1_TCNFG		0x318
 #define HP_ZX1_PDIR_BASE	0x320
-#define HP_ZX1_CACHE_FLUSH	0x428
+
+/* HP ZX1 LBA registers */
+#define HP_ZX1_AGP_STATUS	0x64
+#define HP_ZX1_AGP_COMMAND	0x68
+
+/* ATI register */
+#define ATI_APBASE                  0x10
+#define ATI_GART_MMBASE_ADDR        0x14
+#define ATI_RS100_APSIZE            0xac
+#define ATI_RS300_APSIZE            0xf8
+#define ATI_RS100_IG_AGPMODE        0xb0
+#define ATI_RS300_IG_AGPMODE        0xfc
+
+#define ATI_GART_FEATURE_ID         0x00
+#define ATI_GART_BASE               0x04
+#define ATI_GART_CACHE_SZBASE       0x08
+#define ATI_GART_CACHE_CNTRL        0x0c
+#define ATI_GART_CACHE_ENTRY_CNTRL  0x10
 
 #endif				/* _AGP_BACKEND_PRIV_H */
